// Heyo / TMI_js by Sarimoko.com
// ================================
// Hello World Chatbot for Twitch IRC using TMI.js!
// --------------------------------
// View README.md for .env setup!!!
// --------------------------------
require('dotenv').config();
const tmi = require('tmi.js');

console.log(process.env.API_HOST);

const client = new tmi.Client({
  options: { debug: true },
  connection: {
    secure: true,
    reconnect: true
  },
  identity: {
    username: process.env.TTV_BOT_USERNAME,
    password: process.env.TTV_BOT_OAUTH
  },
  channels: [ process.env.TTV_CHANNELS ]
});

client.connect();

client.on('message', (channel, tags, message, self) => { // START | MSG
    if(self) return; // Bot ignores itself
    const badges = tags.badges || {}; // Scan Badges
    const isBroadcaster = badges.broadcaster; // Define Streamer
    const isMod = badges.moderator; // Define Mod
    const isModUp = isBroadcaster || isMod; // Permission Merge = Mod+Streamer
    const isSub = badges.subscriber || badges.founder; // Define Subs
    const botUserState = client.userstate[channel]; // MOD Status Check
    const amMod = botUserState !== undefined && botUserState.mod === true; // Define Mod Status

    // !MODS
    if(isModUp && message.toLowerCase().startsWith('!so')) {
        console.log('MOD COMMAND | so | shoutout');    
        client.say(channel, `bloop`);
    }

    // !SUBS
    if(isSub) {
      console.log(tags.username, 'is a subscriber');
    }

    // General Commands
    if(message.toLowerCase().startsWith('!2pac')) {
        console.log('LOG: Non-Mod command used!');
    }

}); // END | MSG

// TTV Re-Active
// ==================================
client.on("anongiftpaidupgrade", (channel, username, userstate) => {
    console.log('TTV Alert: Anon2PaidSub...'); // VERY specific... Anon Gift Sub => Paid Re-Sub
});
client.on("ban", (channel, username, reason, userstate) => {
    console.log('TTV Alert: User Banned...'); // BYE FELICIA!
});
client.on("cheer", (channel, userstate, message) => {
    console.log('TTV Alert: Bits Cheered...'); // Get Bits via Cheer then React
});
client.on("clearchat", (channel) => {
    console.log('TTV Alert: Chat Cleared...'); // Chat gets cleared by Mod/Streamer then this Reaction
});
client.on("giftpaidupgrade", (channel, username, sender, userstate) => {
    console.log('TTV Alert: Anon2PaidSub...'); // Huh? Tier 1 => Tier2?
});
client.on("hosting", (channel, target, viewers) => {
    console.log('TTV Alert: Incoming Host...'); // Get Hosted React
});
client.on("join", (channel, username, self) => {
    console.log('TTV Alert: User joined IRC...');// User joins IRC **WARNING: aggro/annoying
});
client.on("part", (channel, username, self) => {
    console.log('TTV Alert: User left IRC...');// User leaves IRC **WARNING: aggro/annoying
});
client.on("raided", (channel, username, viewers) => {
    console.log('TTV Alert: Incoming Raid...');// Get Raided React
});
client.on("subgift", (channel, username, streakMonths, recipient, methods, userstate) => {
    let senderCount = ~~userstate["msg-param-sender-count"];
    console.log('TTV Alert: Sub Gifted...');// Gift Sub React
});
client.on("submysterygift", (channel, username, numbOfSubs, methods, userstate) => {
    let senderCount = ~~userstate["msg-param-sender-count"];
    console.log('TTV Alert: Sub Gifted Anonomously...');// Anon Sub React
});
client.on("resub", function (channel, username, months, message, userstate, methods) {
    console.log('TTV Alert: Sub Re-Subbed...');// Re-Sub React
});
client.on("subscription", function (channel, username, method, message, userstate) {
    console.log('TTV Alert: 1st Sub...'); // Either first or just General Sub
});
client.on("whisper", (from, userstate, message, self) => {
    if (self) return;
    console.log('TTV Alert: DM/Whisper recieved...'); // When your bot gets a DM
});